#include <iostream>
#include <vector>
using namespace std;

struct Input {
	vector<double> numbers;
	size_t bin_count{};
};

Input
input_data()
{
	size_t number_count;
	cin >> number_count;

	Input in;
	in.numbers.resize(number_count);

	for (size_t i = 0; i < number_count; i++) {
		cin >> in.numbers[i];
	}

	cin >> in.bin_count;
	return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
	min = numbers[0]; max = numbers[0];
	for (double x: numbers)
	{
		if (x > max)
			max = x;
		else
		{
			if (x < min)
				min = x;
		}
	}
}

auto
make_histogram(const vector<double>& numbers, size_t bin_count) {
	double min, max;
	find_minmax(numbers, min, max);

	size_t columns = bin_count;
	double lo, hi, diff;

	diff = (max - min) / columns;
	lo = min;

	vector<size_t> bins(columns);
	size_t max_count = 0, count;
	for (int i = 0; i < columns; ++i)
	{
		count = 0;

		if (i != columns - 1)
		{
			hi = lo + diff;
		}
		else
		{
			hi = max;
		}
		for (double x: numbers)
		{
			if (i == 0)
			{
				if ((x >= lo) && (x <= hi))
					count++;
			}

			else
			{
				if ((x > lo) && (x <= hi))
					count++;
			}
		}
		bins[i] = count;
		lo = hi;
	}

	return bins;
}

void
show_histogram_text(vector<size_t>& bins) {
	const size_t SCREEN_WIDTH = 80;
	const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
	size_t height;

	size_t max_count = 0;
	for (size_t x : bins)
	{
		if (max_count < x)
			max_count = x;
	}

	for (size_t x: bins)
	{

		if (x == 0)
			continue;

		if (x < 10)
			cout << "  ";
		else
			if (x < 100)
				cout << " ";

		cout << x << "|";

		if (max_count > MAX_ASTERISK)
			height = MAX_ASTERISK * (static_cast<double>(x) / max_count);
		else
			height = x;

		for (int j = 0; j < height; j++)
		{
			cout << "*";
		}
		cout << endl;
	}
}

int
main()
{
	auto in = input_data();

	auto bins = make_histogram(in.numbers, in.bin_count);

	show_histogram_text(bins);
}
